#---------------------------------------------------------------------------
#
#   SuPy GUI - Check box - Cocoa
#
#---------------------------------------------------------------------------

import AppKit as AK
from AppKit import NSOnState, NSOffState, NSMixedState
from g_check_box import GCheckBox
from button_base import PyNSButton

class CheckBox(GCheckBox):

	_ns_mixed = False

	def __init__(self, title = "Check Box", mixed = False, **kwds):
		ns = PyNSButton.alloc().initWithFrame_(((0, 0), (10, 10)))
		ns.setTitle_(title)
		ns.setButtonType_(AK.NSSwitchButton)
		ns.setBezelStyle_(AK.NSRoundedBezelStyle)
		if mixed:
			self._ns_mixed = True
			ns.setAllowsMixedState_(True)
		ns.sizeToFit()
		GCheckBox.__init__(self, _ns_view = ns, **kwds)
	
	def get_value(self):
		state = self._ns_view.state()
		if state == NSMixedState:
			return 'mixed'
		else:
			return state <> NSOffState

	def set_value(self, v):
		if v == 'mixed' and self._ns_mixed:
			state = NSMixedState
		elif v:
			state = NSOnState
		else:
			state = NSOffState
		self._ns_view.setState_(state)
